Index: branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp
===================================================================
--- branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp	(revision 1199)
+++ branches/HTM-14.1-update-dev0/source/Lib/TLibCommon/TComSampleAdaptiveOffset.cpp	(revision 1200)
@@ -2,5 +2,5 @@
  * License, included below. This software may be subject to other third party
  * and contributor rights, including patent rights, and no such rights are
- * granted under this license.  
+ * granted under this license.
  *
  * Copyright (c) 2010-2015, ITU/ISO/IEC
@@ -44,8 +44,7 @@
 //! \ingroup TLibCommon
 //! \{
-UInt g_saoMaxOffsetQVal[NUM_SAO_COMPONENTS];
 
 SAOOffset::SAOOffset()
-{ 
+{
   reset();
 }
@@ -87,5 +86,5 @@
 Void SAOBlkParam::reset()
 {
-  for(Int compIdx=0; compIdx< 3; compIdx++)
+  for(Int compIdx = 0; compIdx < MAX_NUM_COMPONENT; compIdx++)
   {
     offsetParam[compIdx].reset();
@@ -95,5 +94,5 @@
 const SAOBlkParam& SAOBlkParam::operator= (const SAOBlkParam& src)
 {
-  for(Int compIdx=0; compIdx< 3; compIdx++)
+  for(Int compIdx = 0; compIdx < MAX_NUM_COMPONENT; compIdx++)
   {
     offsetParam[compIdx] = src.offsetParam[compIdx];
@@ -106,12 +105,4 @@
 {
   m_tempPicYuv = NULL;
-  for(Int compIdx=0; compIdx < NUM_SAO_COMPONENTS; compIdx++)
-  {
-    m_offsetClipTable[compIdx] = NULL;
-  }
-#if !SAO_SGN_FUNC
-  m_signTable = NULL; 
-#endif
-  
   m_lineBufWidth = 0;
   m_signLineBuf1 = NULL;
@@ -123,21 +114,30 @@
 {
   destroy();
-  
-  if (m_signLineBuf1) delete[] m_signLineBuf1; m_signLineBuf1 = NULL;
-  if (m_signLineBuf2) delete[] m_signLineBuf2; m_signLineBuf2 = NULL;
-}
-
-Void TComSampleAdaptiveOffset::create( Int picWidth, Int picHeight, UInt maxCUWidth, UInt maxCUHeight, UInt maxCUDepth )
+
+  if (m_signLineBuf1)
+  {
+    delete[] m_signLineBuf1;
+    m_signLineBuf1 = NULL;
+  }
+  if (m_signLineBuf2)
+  {
+    delete[] m_signLineBuf2;
+    m_signLineBuf2 = NULL;
+  }
+}
+
+Void TComSampleAdaptiveOffset::create( Int picWidth, Int picHeight, ChromaFormat format, UInt maxCUWidth, UInt maxCUHeight, UInt maxCUDepth, UInt lumaBitShift, UInt chromaBitShift )
 {
   destroy();
 
-  m_picWidth = picWidth;    
-  m_picHeight= picHeight;
-  m_maxCUWidth= maxCUWidth; 
-  m_maxCUHeight= maxCUHeight;
-
-  m_numCTUInWidth = (m_picWidth/m_maxCUWidth) + ((m_picWidth % m_maxCUWidth)?1:0);
-  m_numCTUInHeight= (m_picHeight/m_maxCUHeight) + ((m_picHeight % m_maxCUHeight)?1:0);
-  m_numCTUsPic = m_numCTUInHeight*m_numCTUInWidth;
+  m_picWidth        = picWidth;
+  m_picHeight       = picHeight;
+  m_chromaFormatIDC = format;
+  m_maxCUWidth      = maxCUWidth;
+  m_maxCUHeight     = maxCUHeight;
+
+  m_numCTUInWidth   = (m_picWidth/m_maxCUWidth) + ((m_picWidth % m_maxCUWidth)?1:0);
+  m_numCTUInHeight  = (m_picHeight/m_maxCUHeight) + ((m_picHeight % m_maxCUHeight)?1:0);
+  m_numCTUsPic      = m_numCTUInHeight*m_numCTUInWidth;
 
   //temporary picture buffer
@@ -145,55 +145,12 @@
   {
     m_tempPicYuv = new TComPicYuv;
-    m_tempPicYuv->create( m_picWidth, m_picHeight, m_maxCUWidth, m_maxCUHeight, maxCUDepth );
+    m_tempPicYuv->create( m_picWidth, m_picHeight, m_chromaFormatIDC, m_maxCUWidth, m_maxCUHeight, maxCUDepth, true );
   }
 
   //bit-depth related
-  for(Int compIdx =0; compIdx < NUM_SAO_COMPONENTS; compIdx++)
-  {
-    Int bitDepthSample = (compIdx == SAO_Y)?g_bitDepthY:g_bitDepthC;
-    m_offsetStepLog2  [compIdx] = max(bitDepthSample - MAX_SAO_TRUNCATED_BITDEPTH, 0);
-    g_saoMaxOffsetQVal[compIdx] = (1<<(min(bitDepthSample,MAX_SAO_TRUNCATED_BITDEPTH)-5))-1; //Table 9-32, inclusive
-  }
-
-#if !SAO_SGN_FUNC
-  //look-up table for clipping
-  Int overallMaxSampleValue=0;
-#endif
-  for(Int compIdx =0; compIdx < NUM_SAO_COMPONENTS; compIdx++)
-  {
-    Int bitDepthSample = (compIdx == SAO_Y)?g_bitDepthY:g_bitDepthC; //exclusive
-    Int maxSampleValue = (1<< bitDepthSample); //exclusive
-    Int maxOffsetValue = (g_saoMaxOffsetQVal[compIdx] << m_offsetStepLog2[compIdx]); 
-#if !SAO_SGN_FUNC
-    if (maxSampleValue>overallMaxSampleValue) overallMaxSampleValue=maxSampleValue;
-#endif
-
-    m_offsetClipTable[compIdx] = new Int[(maxSampleValue + maxOffsetValue -1)+ (maxOffsetValue)+1 ]; //positive & negative range plus 0
-    m_offsetClip[compIdx] = &(m_offsetClipTable[compIdx][maxOffsetValue]);
-
-    //assign clipped values 
-    Int* offsetClipPtr = m_offsetClip[compIdx];
-    for(Int k=0; k< maxSampleValue; k++)
-    {
-      *(offsetClipPtr + k) = k;
-    }
-    for(Int k=0; k< maxOffsetValue; k++ )
-    {
-      *(offsetClipPtr + maxSampleValue+ k) = maxSampleValue-1;
-      *(offsetClipPtr -k -1 )              = 0;
-    }
-  }
-
-#if !SAO_SGN_FUNC
-  m_signTable = new Short[ 2*(overallMaxSampleValue-1) + 1 ];
-  m_sign = &(m_signTable[overallMaxSampleValue-1]);
-
-      m_sign[0] = 0;
-  for(Int k=1; k< overallMaxSampleValue; k++)
-      {
-        m_sign[k] = 1;
-        m_sign[-k]= -1;
-      }
-#endif
+  for(Int compIdx = 0; compIdx < MAX_NUM_COMPONENT; compIdx++)
+  {
+    m_offsetStepLog2  [compIdx] = isLuma(ComponentID(compIdx))? lumaBitShift : chromaBitShift;
+  }
 }
 
@@ -206,21 +163,7 @@
     m_tempPicYuv = NULL;
   }
-
-  for(Int compIdx=0; compIdx < NUM_SAO_COMPONENTS; compIdx++)
-  {
-    if(m_offsetClipTable[compIdx])
-    {
-      delete[] m_offsetClipTable[compIdx]; m_offsetClipTable[compIdx] = NULL;
-    }
-  }
-#if !SAO_SGN_FUNC
-  if( m_signTable )
-  {
-    delete[] m_signTable; m_signTable = NULL;
-  }
-#endif
-}
-
-Void TComSampleAdaptiveOffset::invertQuantOffsets(Int compIdx, Int typeIdc, Int typeAuxInfo, Int* dstOffsets, Int* srcOffsets)
+}
+
+Void TComSampleAdaptiveOffset::invertQuantOffsets(ComponentID compIdx, Int typeIdc, Int typeAuxInfo, Int* dstOffsets, Int* srcOffsets)
 {
   Int codedOffset[MAX_NUM_SAO_CLASSES];
@@ -247,8 +190,8 @@
 }
 
-Int TComSampleAdaptiveOffset::getMergeList(TComPic* pic, Int ctu, SAOBlkParam* blkParams, std::vector<SAOBlkParam*>& mergeList)
-{
-  Int ctuX = ctu % m_numCTUInWidth;
-  Int ctuY = ctu / m_numCTUInWidth;
+Int TComSampleAdaptiveOffset::getMergeList(TComPic* pic, Int ctuRsAddr, SAOBlkParam* blkParams, SAOBlkParam* mergeList[NUM_SAO_MERGE_TYPES])
+{
+  Int ctuX = ctuRsAddr % m_numCTUInWidth;
+  Int ctuY = ctuRsAddr / m_numCTUInWidth;
   Int mergedCTUPos;
   Int numValidMergeCandidates = 0;
@@ -264,6 +207,6 @@
         if(ctuY > 0)
         {
-          mergedCTUPos = ctu- m_numCTUInWidth;
-          if( pic->getSAOMergeAvailability(ctu, mergedCTUPos) )
+          mergedCTUPos = ctuRsAddr- m_numCTUInWidth;
+          if( pic->getSAOMergeAvailability(ctuRsAddr, mergedCTUPos) )
           {
             mergeCandidate = &(blkParams[mergedCTUPos]);
@@ -276,6 +219,6 @@
         if(ctuX > 0)
         {
-          mergedCTUPos = ctu- 1;
-          if( pic->getSAOMergeAvailability(ctu, mergedCTUPos) )
+          mergedCTUPos = ctuRsAddr- 1;
+          if( pic->getSAOMergeAvailability(ctuRsAddr, mergedCTUPos) )
           {
             mergeCandidate = &(blkParams[mergedCTUPos]);
@@ -292,5 +235,5 @@
     }
 
-    mergeList.push_back(mergeCandidate);
+    mergeList[mergeType]=mergeCandidate;
     if (mergeCandidate != NULL)
     {
@@ -303,9 +246,11 @@
 
 
-Void TComSampleAdaptiveOffset::reconstructBlkSAOParam(SAOBlkParam& recParam, std::vector<SAOBlkParam*>& mergeList)
-{
-  for(Int compIdx=0; compIdx< NUM_SAO_COMPONENTS; compIdx++)
-  {
-    SAOOffset& offsetParam = recParam[compIdx];
+Void TComSampleAdaptiveOffset::reconstructBlkSAOParam(SAOBlkParam& recParam, SAOBlkParam* mergeList[NUM_SAO_MERGE_TYPES])
+{
+  const Int numberOfComponents = getNumberValidComponents(m_chromaFormatIDC);
+  for(Int compIdx = 0; compIdx < numberOfComponents; compIdx++)
+  {
+    const ComponentID component = ComponentID(compIdx);
+    SAOOffset& offsetParam = recParam[component];
 
     if(offsetParam.modeIdc == SAO_MODE_OFF)
@@ -318,5 +263,5 @@
     case SAO_MODE_NEW:
       {
-        invertQuantOffsets(compIdx, offsetParam.typeIdc, offsetParam.typeAuxInfo, offsetParam.offset, offsetParam.offset);
+        invertQuantOffsets(component, offsetParam.typeIdc, offsetParam.typeAuxInfo, offsetParam.offset, offsetParam.offset);
       }
       break;
@@ -326,5 +271,5 @@
         assert(mergeTarget != NULL);
 
-        offsetParam = (*mergeTarget)[compIdx];
+        offsetParam = (*mergeTarget)[component];
       }
       break;
@@ -341,16 +286,21 @@
 Void TComSampleAdaptiveOffset::reconstructBlkSAOParams(TComPic* pic, SAOBlkParam* saoBlkParams)
 {
-  m_picSAOEnabled[SAO_Y] = m_picSAOEnabled[SAO_Cb] = m_picSAOEnabled[SAO_Cr] = false;
-
-  for(Int ctu=0; ctu< m_numCTUsPic; ctu++)
-  {
-    std::vector<SAOBlkParam*> mergeList;
-    getMergeList(pic, ctu, saoBlkParams, mergeList);
-
-    reconstructBlkSAOParam(saoBlkParams[ctu], mergeList);
-
-    for(Int compIdx=0; compIdx< NUM_SAO_COMPONENTS; compIdx++)
-    {
-      if(saoBlkParams[ctu][compIdx].modeIdc != SAO_MODE_OFF)
+  for(Int compIdx = 0; compIdx < MAX_NUM_COMPONENT; compIdx++)
+  {
+    m_picSAOEnabled[compIdx] = false;
+  }
+
+  const Int numberOfComponents = getNumberValidComponents(m_chromaFormatIDC);
+
+  for(Int ctuRsAddr=0; ctuRsAddr< m_numCTUsPic; ctuRsAddr++)
+  {
+    SAOBlkParam* mergeList[NUM_SAO_MERGE_TYPES] = { NULL };
+    getMergeList(pic, ctuRsAddr, saoBlkParams, mergeList);
+
+    reconstructBlkSAOParam(saoBlkParams[ctuRsAddr], mergeList);
+
+    for(Int compIdx = 0; compIdx < numberOfComponents; compIdx++)
+    {
+      if(saoBlkParams[ctuRsAddr][compIdx].modeIdc != SAO_MODE_OFF)
       {
         m_picSAOEnabled[compIdx] = true;
@@ -358,10 +308,8 @@
     }
   }
-
-
-}
-
-
-Void TComSampleAdaptiveOffset::offsetBlock(Int compIdx, Int typeIdx, Int* offset  
+}
+
+
+Void TComSampleAdaptiveOffset::offsetBlock(const Int channelBitDepth, Int typeIdx, Int* offset
                                           , Pel* srcBlk, Pel* resBlk, Int srcStride, Int resStride,  Int width, Int height
                                           , Bool isLeftAvail,  Bool isRightAvail, Bool isAboveAvail, Bool isBelowAvail, Bool isAboveLeftAvail, Bool isAboveRightAvail, Bool isBelowLeftAvail, Bool isBelowRightAvail)
@@ -370,13 +318,21 @@
   {
     m_lineBufWidth = m_maxCUWidth;
-    
-    if (m_signLineBuf1) delete[] m_signLineBuf1; m_signLineBuf1 = NULL;
+
+    if (m_signLineBuf1)
+    {
+      delete[] m_signLineBuf1;
+      m_signLineBuf1 = NULL;
+    }
     m_signLineBuf1 = new Char[m_lineBufWidth+1];
-    
-    if (m_signLineBuf2) delete[] m_signLineBuf2; m_signLineBuf2 = NULL;
+
+    if (m_signLineBuf2)
+    {
+      delete[] m_signLineBuf2;
+      m_signLineBuf2 = NULL;
+    }
     m_signLineBuf2 = new Char[m_lineBufWidth+1];
   }
 
-  Int* offsetClip = m_offsetClip[compIdx];
+  const Int maxSampleValueIncl = (1<< channelBitDepth )-1;
 
   Int x,y, startX, startY, endX, endY, edgeType;
@@ -396,20 +352,12 @@
       for (y=0; y< height; y++)
       {
-#if SAO_SGN_FUNC
         signLeft = (Char)sgn(srcLine[startX] - srcLine[startX-1]);
-#else
-        signLeft = (Char)m_sign[srcLine[startX] - srcLine[startX-1]];
-#endif
         for (x=startX; x< endX; x++)
         {
-#if SAO_SGN_FUNC
           signRight = (Char)sgn(srcLine[x] - srcLine[x+1]); 
-#else
-          signRight = (Char)m_sign[srcLine[x] - srcLine[x+1]]; 
-#endif
           edgeType =  signRight + signLeft;
           signLeft  = -signRight;
 
-          resLine[x] = offsetClip[srcLine[x] + offset[edgeType]];
+          resLine[x] = Clip3<Int>(0, maxSampleValueIncl, srcLine[x] + offset[edgeType]);
         }
         srcLine  += srcStride;
@@ -435,9 +383,5 @@
       for (x=0; x< width; x++)
       {
-#if SAO_SGN_FUNC
         signUpLine[x] = (Char)sgn(srcLine[x] - srcLineAbove[x]);
-#else
-        signUpLine[x] = (Char)m_sign[srcLine[x] - srcLineAbove[x]];
-#endif
       }
 
@@ -449,13 +393,9 @@
         for (x=0; x< width; x++)
         {
-#if SAO_SGN_FUNC
           signDown  = (Char)sgn(srcLine[x] - srcLineBelow[x]);
-#else
-          signDown  = (Char)m_sign[srcLine[x] - srcLineBelow[x]]; 
-#endif
           edgeType = signDown + signUpLine[x];
           signUpLine[x]= -signDown;
 
-          resLine[x] = offsetClip[srcLine[x] + offset[edgeType]];
+          resLine[x] = Clip3<Int>(0, maxSampleValueIncl, srcLine[x] + offset[edgeType]);
         }
         srcLine += srcStride;
@@ -480,9 +420,5 @@
       for (x=startX; x< endX+1; x++)
       {
-#if SAO_SGN_FUNC
         signUpLine[x] = (Char)sgn(srcLineBelow[x] - srcLine[x- 1]);
-#else
-        signUpLine[x] = (Char)m_sign[srcLineBelow[x] - srcLine[x- 1]];
-#endif
       }
 
@@ -493,10 +429,7 @@
       for(x= firstLineStartX; x< firstLineEndX; x++)
       {
-#if SAO_SGN_FUNC
         edgeType  =  sgn(srcLine[x] - srcLineAbove[x- 1]) - signUpLine[x+1];
-#else
-        edgeType  =  m_sign[srcLine[x] - srcLineAbove[x- 1]] - signUpLine[x+1];
-#endif
-        resLine[x] = offsetClip[srcLine[x] + offset[edgeType]];
+
+        resLine[x] = Clip3<Int>(0, maxSampleValueIncl, srcLine[x] + offset[edgeType]);
       }
       srcLine  += srcStride;
@@ -511,19 +444,11 @@
         for (x=startX; x<endX; x++)
         {
-#if SAO_SGN_FUNC
           signDown =  (Char)sgn(srcLine[x] - srcLineBelow[x+ 1]);
-#else
-          signDown =  (Char)m_sign[srcLine[x] - srcLineBelow[x+ 1]] ;
-#endif
           edgeType =  signDown + signUpLine[x];
-          resLine[x] = offsetClip[srcLine[x] + offset[edgeType]];
-
-          signDownLine[x+1] = -signDown; 
+          resLine[x] = Clip3<Int>(0, maxSampleValueIncl, srcLine[x] + offset[edgeType]);
+
+          signDownLine[x+1] = -signDown;
         }
-#if SAO_SGN_FUNC
         signDownLine[startX] = (Char)sgn(srcLineBelow[startX] - srcLine[startX-1]);
-#else
-        signDownLine[startX] = (Char)m_sign[srcLineBelow[startX] - srcLine[startX-1]];
-#endif
 
         signTmpLine  = signUpLine;
@@ -541,10 +466,6 @@
       for(x= lastLineStartX; x< lastLineEndX; x++)
       {
-#if SAO_SGN_FUNC
         edgeType =  sgn(srcLine[x] - srcLineBelow[x+ 1]) + signUpLine[x];
-#else
-        edgeType =  m_sign[srcLine[x] - srcLineBelow[x+ 1]] + signUpLine[x];
-#endif
-        resLine[x] = offsetClip[srcLine[x] + offset[edgeType]];
+        resLine[x] = Clip3<Int>(0, maxSampleValueIncl, srcLine[x] + offset[edgeType]);
 
       }
@@ -563,9 +484,5 @@
       for (x=startX-1; x< endX; x++)
       {
-#if SAO_SGN_FUNC
         signUpLine[x] = (Char)sgn(srcLineBelow[x] - srcLine[x+1]);
-#else
-        signUpLine[x] = (Char)m_sign[srcLineBelow[x] - srcLine[x+1]];
-#endif
       }
 
@@ -577,10 +494,6 @@
       for(x= firstLineStartX; x< firstLineEndX; x++)
       {
-#if SAO_SGN_FUNC
         edgeType = sgn(srcLine[x] - srcLineAbove[x+1]) -signUpLine[x-1];
-#else
-        edgeType = m_sign[srcLine[x] - srcLineAbove[x+1]] -signUpLine[x-1];
-#endif
-        resLine[x] = offsetClip[srcLine[x] + offset[edgeType]];
+        resLine[x] = Clip3<Int>(0, maxSampleValueIncl, srcLine[x] + offset[edgeType]);
       }
       srcLine += srcStride;
@@ -594,18 +507,10 @@
         for(x= startX; x< endX; x++)
         {
-#if SAO_SGN_FUNC
           signDown =  (Char)sgn(srcLine[x] - srcLineBelow[x-1]);
-#else
-          signDown =  (Char)m_sign[srcLine[x] - srcLineBelow[x-1]] ;
-#endif
           edgeType =  signDown + signUpLine[x];
-          resLine[x] = offsetClip[srcLine[x] + offset[edgeType]];
-          signUpLine[x-1] = -signDown; 
+          resLine[x] = Clip3<Int>(0, maxSampleValueIncl, srcLine[x] + offset[edgeType]);
+          signUpLine[x-1] = -signDown;
         }
-#if SAO_SGN_FUNC
         signUpLine[endX-1] = (Char)sgn(srcLineBelow[endX-1] - srcLine[endX]);
-#else
-        signUpLine[endX-1] = (Char)m_sign[srcLineBelow[endX-1] - srcLine[endX]];
-#endif
         srcLine  += srcStride;
         resLine += resStride;
@@ -618,10 +523,6 @@
       for(x= lastLineStartX; x< lastLineEndX; x++)
       {
-#if SAO_SGN_FUNC
         edgeType = sgn(srcLine[x] - srcLineBelow[x-1]) + signUpLine[x];
-#else
-        edgeType = m_sign[srcLine[x] - srcLineBelow[x-1]] + signUpLine[x];
-#endif
-        resLine[x] = offsetClip[srcLine[x] + offset[edgeType]];
+        resLine[x] = Clip3<Int>(0, maxSampleValueIncl, srcLine[x] + offset[edgeType]);
 
       }
@@ -630,10 +531,10 @@
   case SAO_TYPE_BO:
     {
-      Int shiftBits = ((compIdx == SAO_Y)?g_bitDepthY:g_bitDepthC)- NUM_SAO_BO_CLASSES_LOG2;
+      const Int shiftBits = channelBitDepth - NUM_SAO_BO_CLASSES_LOG2;
       for (y=0; y< height; y++)
       {
         for (x=0; x< width; x++)
         {
-          resLine[x] = offsetClip[ srcLine[x] + offset[srcLine[x] >> shiftBits] ];
+          resLine[x] = Clip3<Int>(0, maxSampleValueIncl, srcLine[x] + offset[srcLine[x] >> shiftBits] );
         }
         srcLine += srcStride;
@@ -649,17 +550,20 @@
     }
   }
-
-
-}
-
-Void TComSampleAdaptiveOffset::offsetCTU(Int ctu, TComPicYuv* srcYuv, TComPicYuv* resYuv, SAOBlkParam& saoblkParam, TComPic* pPic)
+}
+
+Void TComSampleAdaptiveOffset::offsetCTU(Int ctuRsAddr, TComPicYuv* srcYuv, TComPicYuv* resYuv, SAOBlkParam& saoblkParam, TComPic* pPic)
 {
   Bool isLeftAvail,isRightAvail,isAboveAvail,isBelowAvail,isAboveLeftAvail,isAboveRightAvail,isBelowLeftAvail,isBelowRightAvail;
 
-  if( 
-    (saoblkParam[SAO_Y ].modeIdc == SAO_MODE_OFF) &&
-    (saoblkParam[SAO_Cb].modeIdc == SAO_MODE_OFF) &&
-    (saoblkParam[SAO_Cr].modeIdc == SAO_MODE_OFF)
-    )
+  const Int numberOfComponents = getNumberValidComponents(m_chromaFormatIDC);
+  Bool bAllOff=true;
+  for(Int compIdx = 0; compIdx < numberOfComponents; compIdx++)
+  {
+    if (saoblkParam[compIdx].modeIdc != SAO_MODE_OFF)
+    {
+      bAllOff=false;
+    }
+  }
+  if (bAllOff)
   {
     return;
@@ -667,32 +571,33 @@
 
   //block boundary availability
-  pPic->getPicSym()->deriveLoopFilterBoundaryAvailibility(ctu, isLeftAvail,isRightAvail,isAboveAvail,isBelowAvail,isAboveLeftAvail,isAboveRightAvail,isBelowLeftAvail,isBelowRightAvail);
-
-  Int yPos   = (ctu / m_numCTUInWidth)*m_maxCUHeight;
-  Int xPos   = (ctu % m_numCTUInWidth)*m_maxCUWidth;
+  pPic->getPicSym()->deriveLoopFilterBoundaryAvailibility(ctuRsAddr, isLeftAvail,isRightAvail,isAboveAvail,isBelowAvail,isAboveLeftAvail,isAboveRightAvail,isBelowLeftAvail,isBelowRightAvail);
+
+  Int yPos   = (ctuRsAddr / m_numCTUInWidth)*m_maxCUHeight;
+  Int xPos   = (ctuRsAddr % m_numCTUInWidth)*m_maxCUWidth;
   Int height = (yPos + m_maxCUHeight > m_picHeight)?(m_picHeight- yPos):m_maxCUHeight;
   Int width  = (xPos + m_maxCUWidth  > m_picWidth )?(m_picWidth - xPos):m_maxCUWidth;
 
-  for(Int compIdx= 0; compIdx < NUM_SAO_COMPONENTS; compIdx++)
-  {
+  for(Int compIdx = 0; compIdx < numberOfComponents; compIdx++)
+  {
+    const ComponentID component = ComponentID(compIdx);
     SAOOffset& ctbOffset = saoblkParam[compIdx];
 
     if(ctbOffset.modeIdc != SAO_MODE_OFF)
     {
-      Bool isLuma     = (compIdx == SAO_Y);
-      Int  formatShift= isLuma?0:1;
-
-      Int  blkWidth   = (width  >> formatShift);
-      Int  blkHeight  = (height >> formatShift);
-      Int  blkYPos    = (yPos   >> formatShift);
-      Int  blkXPos    = (xPos   >> formatShift);
-
-      Int  srcStride = isLuma?srcYuv->getStride():srcYuv->getCStride();
-      Pel* srcBlk    = getPicBuf(srcYuv, compIdx)+ (yPos >> formatShift)*srcStride+ (xPos >> formatShift);
-
-      Int  resStride  = isLuma?resYuv->getStride():resYuv->getCStride();
-      Pel* resBlk     = getPicBuf(resYuv, compIdx)+ blkYPos*resStride+ blkXPos;
-
-      offsetBlock( compIdx, ctbOffset.typeIdc, ctbOffset.offset
+      const UInt componentScaleX = getComponentScaleX(component, pPic->getChromaFormat());
+      const UInt componentScaleY = getComponentScaleY(component, pPic->getChromaFormat());
+
+      Int  blkWidth   = (width  >> componentScaleX);
+      Int  blkHeight  = (height >> componentScaleY);
+      Int  blkXPos    = (xPos   >> componentScaleX);
+      Int  blkYPos    = (yPos   >> componentScaleY);
+
+      Int  srcStride  = srcYuv->getStride(component);
+      Pel* srcBlk     = srcYuv->getAddr(component) + blkYPos*srcStride + blkXPos;
+
+      Int  resStride  = resYuv->getStride(component);
+      Pel* resBlk     = resYuv->getAddr(component) + blkYPos*resStride + blkXPos;
+
+      offsetBlock( pPic->getPicSym()->getSPS().getBitDepth(toChannelType(component)), ctbOffset.typeIdc, ctbOffset.offset
                   , srcBlk, resBlk, srcStride, resStride, blkWidth, blkHeight
                   , isLeftAvail, isRightAvail
@@ -709,52 +614,30 @@
 Void TComSampleAdaptiveOffset::SAOProcess(TComPic* pDecPic)
 {
-  if(!m_picSAOEnabled[SAO_Y] && !m_picSAOEnabled[SAO_Cb] && !m_picSAOEnabled[SAO_Cr])
+  const Int numberOfComponents = getNumberValidComponents(m_chromaFormatIDC);
+  Bool bAllDisabled=true;
+  for(Int compIdx = 0; compIdx < numberOfComponents; compIdx++)
+  {
+    if (m_picSAOEnabled[compIdx])
+    {
+      bAllDisabled=false;
+    }
+  }
+  if (bAllDisabled)
   {
     return;
   }
+
   TComPicYuv* resYuv = pDecPic->getPicYuvRec();
   TComPicYuv* srcYuv = m_tempPicYuv;
   resYuv->copyToPic(srcYuv);
-  for(Int ctu= 0; ctu < m_numCTUsPic; ctu++)
-  {
-    offsetCTU(ctu, srcYuv, resYuv, (pDecPic->getPicSym()->getSAOBlkParam())[ctu], pDecPic);
+  for(Int ctuRsAddr= 0; ctuRsAddr < m_numCTUsPic; ctuRsAddr++)
+  {
+    offsetCTU(ctuRsAddr, srcYuv, resYuv, (pDecPic->getPicSym()->getSAOBlkParam())[ctuRsAddr], pDecPic);
   } //ctu
 }
 
-
-Pel* TComSampleAdaptiveOffset::getPicBuf(TComPicYuv* pPicYuv, Int compIdx)
-{
-  Pel* pBuf = NULL;
-  switch(compIdx)
-  {
-  case SAO_Y:
-    {
-      pBuf = pPicYuv->getLumaAddr();
-    }
-    break;
-  case SAO_Cb:
-    {
-      pBuf = pPicYuv->getCbAddr();
-    }
-    break;
-  case SAO_Cr:
-    {
-      pBuf = pPicYuv->getCrAddr();
-    }
-    break;
-  default:
-    {
-      printf("Not a legal component ID for SAO\n");
-      assert(0);
-      exit(-1);
-    }
-  }
-
-  return pBuf;
-}
 
 /** PCM LF disable process.
  * \param pcPic picture (TComPic) pointer
- * \returns Void
  *
  * \note Replace filtered sample values of PCM mode blocks with the transmitted and reconstructed ones.
@@ -765,7 +648,6 @@
 }
 
-/** Picture-level PCM restoration. 
+/** Picture-level PCM restoration.
  * \param pcPic picture (TComPic) pointer
- * \returns Void
  */
 Void TComSampleAdaptiveOffset::xPCMRestoration(TComPic* pcPic)
@@ -775,23 +657,22 @@
   if(bPCMFilter || pcPic->getSlice(0)->getPPS()->getTransquantBypassEnableFlag())
   {
-    for( UInt uiCUAddr = 0; uiCUAddr < pcPic->getNumCUsInFrame() ; uiCUAddr++ )
-    {
-      TComDataCU* pcCU = pcPic->getCU(uiCUAddr);
-
-      xPCMCURestoration(pcCU, 0, 0); 
-    } 
-  }
-}
-
-/** PCM CU restoration. 
- * \param pcCU pointer to current CU
- * \param uiAbsPartIdx part index
- * \param uiDepth CU depth
- * \returns Void
+    for( UInt ctuRsAddr = 0; ctuRsAddr < pcPic->getNumberOfCtusInFrame() ; ctuRsAddr++ )
+    {
+      TComDataCU* pcCU = pcPic->getCtu(ctuRsAddr);
+
+      xPCMCURestoration(pcCU, 0, 0);
+    }
+  }
+}
+
+/** PCM CU restoration.
+ * \param pcCU            pointer to current CU
+ * \param uiAbsZorderIdx  part index
+ * \param uiDepth         CU depth
  */
 Void TComSampleAdaptiveOffset::xPCMCURestoration ( TComDataCU* pcCU, UInt uiAbsZorderIdx, UInt uiDepth )
 {
   TComPic* pcPic     = pcCU->getPic();
-  UInt uiCurNumParts = pcPic->getNumPartInCU() >> (uiDepth<<1);
+  UInt uiCurNumParts = pcPic->getNumPartitionsInCtu() >> (uiDepth<<1);
   UInt uiQNumParts   = uiCurNumParts>>2;
 
@@ -804,5 +685,7 @@
       UInt uiTPelY   = pcCU->getCUPelY() + g_auiRasterToPelY[ g_auiZscanToRaster[uiAbsZorderIdx] ];
       if( ( uiLPelX < pcCU->getSlice()->getSPS()->getPicWidthInLumaSamples() ) && ( uiTPelY < pcCU->getSlice()->getSPS()->getPicHeightInLumaSamples() ) )
+      {
         xPCMCURestoration( pcCU, uiAbsZorderIdx, uiDepth+1 );
+      }
     }
     return;
@@ -812,76 +695,46 @@
   if ((pcCU->getIPCMFlag(uiAbsZorderIdx)&& pcPic->getSlice(0)->getSPS()->getPCMFilterDisableFlag()) || pcCU->isLosslessCoded( uiAbsZorderIdx))
   {
-    xPCMSampleRestoration (pcCU, uiAbsZorderIdx, uiDepth, TEXT_LUMA    );
-    xPCMSampleRestoration (pcCU, uiAbsZorderIdx, uiDepth, TEXT_CHROMA_U);
-    xPCMSampleRestoration (pcCU, uiAbsZorderIdx, uiDepth, TEXT_CHROMA_V);
-  }
-}
-
-/** PCM sample restoration. 
- * \param pcCU pointer to current CU
- * \param uiAbsPartIdx part index
- * \param uiDepth CU depth
- * \param ttText texture component type
- * \returns Void
+    const UInt numComponents=pcPic->getNumberValidComponents();
+    for(UInt comp=0; comp<numComponents; comp++)
+    {
+      xPCMSampleRestoration (pcCU, uiAbsZorderIdx, uiDepth, ComponentID(comp));
+    }
+  }
+}
+
+/** PCM sample restoration.
+ * \param pcCU           pointer to current CU
+ * \param uiAbsZorderIdx part index
+ * \param uiDepth        CU depth
+ * \param compID         texture component type
  */
-Void TComSampleAdaptiveOffset::xPCMSampleRestoration (TComDataCU* pcCU, UInt uiAbsZorderIdx, UInt uiDepth, TextType ttText)
-{
-  TComPicYuv* pcPicYuvRec = pcCU->getPic()->getPicYuvRec();
-  Pel* piSrc;
-  Pel* piPcm;
-  UInt uiStride;
-  UInt uiWidth;
-  UInt uiHeight;
-  UInt uiPcmLeftShiftBit; 
-  UInt uiX, uiY;
-  UInt uiMinCoeffSize = pcCU->getPic()->getMinCUWidth()*pcCU->getPic()->getMinCUHeight();
-  UInt uiLumaOffset   = uiMinCoeffSize*uiAbsZorderIdx;
-  UInt uiChromaOffset = uiLumaOffset>>2;
-
-  if( ttText == TEXT_LUMA )
-  {
-    piSrc = pcPicYuvRec->getLumaAddr( pcCU->getAddr(), uiAbsZorderIdx);
-    piPcm = pcCU->getPCMSampleY() + uiLumaOffset;
-    uiStride  = pcPicYuvRec->getStride();
-    uiWidth  = (g_uiMaxCUWidth >> uiDepth);
-    uiHeight = (g_uiMaxCUHeight >> uiDepth);
-    if ( pcCU->isLosslessCoded(uiAbsZorderIdx) && !pcCU->getIPCMFlag(uiAbsZorderIdx) )
-    {
-      uiPcmLeftShiftBit = 0;
-    }
-    else
-    {
-      uiPcmLeftShiftBit = g_bitDepthY - pcCU->getSlice()->getSPS()->getPCMBitDepthLuma();
-    }
+Void TComSampleAdaptiveOffset::xPCMSampleRestoration (TComDataCU* pcCU, UInt uiAbsZorderIdx, UInt uiDepth, const ComponentID compID)
+{
+        TComPicYuv* pcPicYuvRec = pcCU->getPic()->getPicYuvRec();
+        UInt uiPcmLeftShiftBit;
+  const UInt uiMinCoeffSize = pcCU->getPic()->getMinCUWidth()*pcCU->getPic()->getMinCUHeight();
+  const UInt csx=pcPicYuvRec->getComponentScaleX(compID);
+  const UInt csy=pcPicYuvRec->getComponentScaleY(compID);
+  const UInt uiOffset   = (uiMinCoeffSize*uiAbsZorderIdx)>>(csx+csy);
+
+        Pel *piSrc = pcPicYuvRec->getAddr(compID, pcCU->getCtuRsAddr(), uiAbsZorderIdx);
+  const Pel *piPcm = pcCU->getPCMSample(compID) + uiOffset;
+  const UInt uiStride  = pcPicYuvRec->getStride(compID);
+  const TComSPS &sps = *(pcCU->getSlice()->getSPS());
+  const UInt uiWidth  = ((sps.getMaxCUWidth()  >> uiDepth) >> csx);
+  const UInt uiHeight = ((sps.getMaxCUHeight() >> uiDepth) >> csy);
+
+  if ( pcCU->isLosslessCoded(uiAbsZorderIdx) && !pcCU->getIPCMFlag(uiAbsZorderIdx) )
+  {
+    uiPcmLeftShiftBit = 0;
   }
   else
   {
-    if( ttText == TEXT_CHROMA_U )
-    {
-      piSrc = pcPicYuvRec->getCbAddr( pcCU->getAddr(), uiAbsZorderIdx );
-      piPcm = pcCU->getPCMSampleCb() + uiChromaOffset;
-    }
-    else
-    {
-      piSrc = pcPicYuvRec->getCrAddr( pcCU->getAddr(), uiAbsZorderIdx );
-      piPcm = pcCU->getPCMSampleCr() + uiChromaOffset;
-    }
-
-    uiStride = pcPicYuvRec->getCStride();
-    uiWidth  = ((g_uiMaxCUWidth >> uiDepth)/2);
-    uiHeight = ((g_uiMaxCUWidth >> uiDepth)/2);
-    if ( pcCU->isLosslessCoded(uiAbsZorderIdx) && !pcCU->getIPCMFlag(uiAbsZorderIdx) )
-    {
-      uiPcmLeftShiftBit = 0;
-    }
-    else
-    {
-      uiPcmLeftShiftBit = g_bitDepthC - pcCU->getSlice()->getSPS()->getPCMBitDepthChroma();
-    }
-  }
-
-  for( uiY = 0; uiY < uiHeight; uiY++ )
-  {
-    for( uiX = 0; uiX < uiWidth; uiX++ )
+    uiPcmLeftShiftBit = sps.getBitDepth(toChannelType(compID)) - sps.getPCMBitDepth(toChannelType(compID));
+  }
+
+  for(UInt uiY = 0; uiY < uiHeight; uiY++ )
+  {
+    for(UInt uiX = 0; uiX < uiWidth; uiX++ )
     {
       piSrc[uiX] = (piPcm[uiX] << uiPcmLeftShiftBit);
